unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, RzPanel, RzButton, StdCtrls, Mask, RzEdit, RzLabel, RzLine;

type
  TForm1 = class(TForm)
    pnlChoises: TRzPanel;
    lbl2: TRzLabel;
    pnl2: TRzPanel;
    edtPort: TRzEdit;
    lbl5: TRzLabel;
    btnAPacket: TButton;
    btnBPacket: TButton;
    cbbPrice: TComboBox;
    cbbName: TComboBox;
    lbl1: TRzLabel;
    lbl4: TRzLabel;
    lbl6: TRzLabel;
    cbbCurrencySample: TComboBox;
    cbbAddText: TComboBox;
    lblPacketType: TRzLabel;
    ckReadFromFile: TCheckBox;
    btndllIsLoadded: TButton;
    cbbCurency: TComboBox;
    lbl3: TRzLabel;
    rzln1: TRzLine;
    rzln2: TRzLine;
    procedure btnAPacketClick(Sender: TObject);
    procedure btnBPacketClick(Sender: TObject);
    procedure myServerCall(ScanedBarcode:string;out
    NAME,PRICE,CURRENCY,GRAPHICS_NAME,GRAPHICS_TIME,SOUND_NAME,ATTR,ADD_TEXT:string);
    procedure SearchForBarcodeInFile(ScanedBarcode:string;out NAME,PRICE,CURRENCY,ADD_TEXT:string);
    procedure btndllIsLoaddedClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ckReadFromFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  Form1: TForm1;
   //the type of the avalible currency sound in this dll
   type TCountrySound=(PalestineSound,SyriaSound,LebanonSound,JordanSound,IraqSound ,SaudiaArabiaSound,UAE,EgyptSound,KuwaitSound,QatarSound,LibyaSound,AlgeriaSound);

   //the type for the metod to be called from the dll
   type
    TMyServerCall = procedure(ScanedBarcode:string;out
    NAME,PRICE,CURRENCY,GRAPHICS_NAME,GRAPHICS_TIME,SOUND_NAME,ATTR,ADD_TEXT:string) of object;

   //the dll funtion call to be used in the file
   procedure Inint_Server_With_B_Packet(_port,_country:integer); StdCall; external 'ELZAB_ARABIC.dll';
   procedure Inint_Server_With_A_Packet(_port,_country:integer); StdCall; external 'ELZAB_ARABIC.dll';
   procedure On_Call(_Call:TMyServerCall); StdCall; external 'ELZAB_ARABIC.dll';
   function  Is_Dll_Loaded:Boolean; StdCall; external 'ELZAB_ARABIC.dll';
   procedure Save_Scanned_Barcode_To_File; StdCall;external 'ELZAB_ARABIC.dll';
   
implementation

{$R *.dfm}
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.btndllIsLoaddedClick(Sender: TObject);
begin
 Is_Dll_Loaded();
end;
procedure TForm1.ckReadFromFileClick(Sender: TObject);
begin
pnlChoises.Enabled:=not pnlChoises.Enabled;
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Save_Scanned_Barcode_To_File();
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.btnAPacketClick(Sender: TObject);
begin
  On_Call(myServerCall);
  Inint_Server_With_A_Packet(StrToInt(edtPort.Text),cbbCurency.ItemIndex);
  lblPacketType.Caption:='Paket Type A Frame';
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.btnBPacketClick(Sender: TObject);
begin
  On_Call(myServerCall);
  Inint_Server_With_B_Packet(StrToInt(edtPort.Text),cbbCurency.ItemIndex);
  lblPacketType.Caption:='Paket Type B Frame';
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.myServerCall(ScanedBarcode:string;out
    NAME,PRICE,CURRENCY,GRAPHICS_NAME,GRAPHICS_TIME,SOUND_NAME,ATTR,ADD_TEXT:string);
begin
    if(ckReadFromFile.Checked)then
    begin
        SearchForBarcodeInFile(ScanedBarcode,NAME,PRICE,CURRENCY,ADD_TEXT);

    end
    else
    begin

    //here do the wanted searche for the barcode and change the value to been showed in the price checker
    NAME:=cbbName.Text;
    PRICE:=cbbPrice.Text;
    CURRENCY:=cbbCurrencySample.Text;
    ADD_TEXT:=cbbAddText.Text;
    GRAPHICS_NAME:='tv.bmp';
    //SOUND_NAME:='tv.wav';

    //the ScanedBarcode didn't changed
    ScanedBarcode:='barcode did not changed';
    end;

            ATTR:='000';
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.SearchForBarcodeInFile(ScanedBarcode:string;out NAME,PRICE,CURRENCY,ADD_TEXT:string);
var
tmpFile, tmpLine: TStringList;
i: integer;
Path: String;
begin
    Path:= ExtractFilePath(ParamStr(0));

    tmpFile := TStringList.Create;
    tmpLine := TStringList.Create;
    try
    tmpLine.Delimiter := #9; //tab char
    tmpFile.LoadFromFile(Path+'dataBase.txt');

      for i:=0 to tmpFile.Count - 1 do
      begin
      tmpLine.DelimitedText := tmpFile[i];
      
      if(tmpLine.Count>0)and(ScanedBarcode=Trim(tmpLine[0]))then
      begin
         PRICE:=Trim(tmpLine[1]);
         NAME:=Trim(tmpLine[2]);
         CURRENCY:=Trim(tmpLine[3]);
         ADD_TEXT:=Trim(tmpLine[4]);
         Break;
      end;
      
      tmpLine.Clear;
      end;

    finally
    FreeAndNil( tmpFile );
    FreeAndNil( tmpLine );
    end;
end;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

end.
